Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -3537,197 +3545,388 @@
             return STATUS_INTERNAL_ERROR;
         }
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static root* find_default_subvol(device_extension* Vcb, PIRP Irp) {
+_Ret_maybenull_
+static root* find_default_subvol(_In_ _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, _In_opt_ PIRP Irp) {
     LIST_ENTRY* le;
-    
+
     static char fn[] = "default";
     static UINT32 crc32 = 0x8dbfc2d2;
-    
+
     if (Vcb->options.subvol_id != 0) {
         le = Vcb->roots.Flink;
         while (le != &Vcb->roots) {
             root* r = CONTAINING_RECORD(le, root, list_entry);
-            
+
             if (r->id == Vcb->options.subvol_id)
                 return r;
-            
+
             le = le->Flink;
         }
     }
-    
+
     if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_DEFAULT_SUBVOL) {
         NTSTATUS Status;
         KEY searchkey;
         traverse_ptr tp;
         DIR_ITEM* di;
-        
+
         searchkey.obj_id = Vcb->superblock.root_dir_objectid;
         searchkey.obj_type = TYPE_DIR_ITEM;
         searchkey.offset = crc32;
-        
+
         Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             goto end;
         }
-        
+
         if (keycmp(tp.item->key, searchkey)) {
             ERR("could not find (%llx,%x,%llx) in root tree\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
             goto end;
         }
-        
+
         if (tp.item->size < sizeof(DIR_ITEM)) {
             ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
             goto end;
         }
-        
+
         di = (DIR_ITEM*)tp.item->data;
-        
+
         if (tp.item->size < sizeof(DIR_ITEM) - 1 + di->n) {
             ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM) - 1 + di->n);
             goto end;
         }
-        
+
         if (di->n != strlen(fn) || RtlCompareMemory(di->name, fn, di->n) != di->n) {
             ERR("root DIR_ITEM had same CRC32, but was not \"default\"\n");
             goto end;
         }
-        
+
         if (di->key.obj_type != TYPE_ROOT_ITEM) {
             ERR("default root has key (%llx,%x,%llx), expected subvolume\n", di->key.obj_id, di->key.obj_type, di->key.offset);
             goto end;
         }
-        
+
         le = Vcb->roots.Flink;
         while (le != &Vcb->roots) {
             root* r = CONTAINING_RECORD(le, root, list_entry);
-            
+
             if (r->id == di->key.obj_id)
                 return r;
-            
+
             le = le->Flink;
         }
-        
+
         ERR("could not find root %llx, using default instead\n", di->key.obj_id);
     }
-    
+
 end:
     le = Vcb->roots.Flink;
     while (le != &Vcb->roots) {
         root* r = CONTAINING_RECORD(le, root, list_entry);
-        
+
         if (r->id == BTRFS_ROOT_FSTREE)
             return r;
-        
+
         le = le->Flink;
     }
-    
+
     return NULL;
 }
 
-void init_file_cache(PFILE_OBJECT FileObject, CC_FILE_SIZES* ccfs) {
+void init_file_cache(_In_ PFILE_OBJECT FileObject, _In_ CC_FILE_SIZES* ccfs) {
     TRACE("(%p, %p)\n", FileObject, ccfs);
-    
+
     CcInitializeCacheMap(FileObject, ccfs, FALSE, cache_callbacks, FileObject);
-    
+
     if (diskacc)
-        CcSetAdditionalCacheAttributesEx(FileObject, CC_ENABLE_DISK_IO_ACCOUNTING);
+        fCcSetAdditionalCacheAttributesEx(FileObject, CC_ENABLE_DISK_IO_ACCOUNTING);
 
     CcSetReadAheadGranularity(FileObject, READ_AHEAD_GRANULARITY);
 }
 
-static NTSTATUS create_calc_threads(PDEVICE_OBJECT DeviceObject) {
+static NTSTATUS create_calc_threads(_In_ PDEVICE_OBJECT DeviceObject) {
     device_extension* Vcb = DeviceObject->DeviceExtension;
     ULONG i;
-    
+
     Vcb->calcthreads.num_threads = KeQueryActiveProcessorCount(NULL);
-    
+
     Vcb->calcthreads.threads = ExAllocatePoolWithTag(NonPagedPool, sizeof(drv_calc_thread) * Vcb->calcthreads.num_threads, ALLOC_TAG);
     if (!Vcb->calcthreads.threads) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     InitializeListHead(&Vcb->calcthreads.job_list);
     ExInitializeResourceLite(&Vcb->calcthreads.lock);
     KeInitializeEvent(&Vcb->calcthreads.event, NotificationEvent, FALSE);
-    
+
     RtlZeroMemory(Vcb->calcthreads.threads, sizeof(drv_calc_thread) * Vcb->calcthreads.num_threads);
-    
+
     for (i = 0; i < Vcb->calcthreads.num_threads; i++) {
         NTSTATUS Status;
-        
+
         Vcb->calcthreads.threads[i].DeviceObject = DeviceObject;
         KeInitializeEvent(&Vcb->calcthreads.threads[i].finished, NotificationEvent, FALSE);
-        
+
         Status = PsCreateSystemThread(&Vcb->calcthreads.threads[i].handle, 0, NULL, NULL, NULL, calc_thread, &Vcb->calcthreads.threads[i]);
         if (!NT_SUCCESS(Status)) {
             ULONG j;
-            
+
             ERR("PsCreateSystemThread returned %08x\n", Status);
-            
+
             for (j = 0; j < i; j++) {
                 Vcb->calcthreads.threads[i].quit = TRUE;
             }
-            
+
             KeSetEvent(&Vcb->calcthreads.event, 0, FALSE);
-            
+
             return Status;
         }
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static BOOL raid_generations_okay(device_extension* Vcb) {
-    LIST_ENTRY* le2;
-    
-    // FIXME - if the difference between superblocks is small, we should try to recover
-    
-    le2 = Vcb->devices.Flink;
-    while (le2 != &Vcb->devices) {
-        LIST_ENTRY* le;
-        device* dev = CONTAINING_RECORD(le2, device, list_entry);
-        
-        ExAcquireResourceSharedLite(&volumes_lock, TRUE);
-        
-        le = volumes.Flink;
-        
-        while (le != &volumes) {
-            volume* v = CONTAINING_RECORD(le, volume, list_entry);
-            
-            if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID) &&
-                RtlCompareMemory(&dev->devitem.device_uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)
-            ) {
-                if (v->gen1 != Vcb->superblock.generation - 1) {
-                    WARN("device %llu had generation %llx, expected %llx\n", dev->devitem.dev_id, v->gen1, Vcb->superblock.generation - 1);
-                    ExReleaseResourceLite(&volumes_lock);
-                    return FALSE;
-                } else
-                    break;
+static BOOL is_btrfs_volume(_In_ PDEVICE_OBJECT DeviceObject) {
+    NTSTATUS Status;
+    MOUNTDEV_NAME mdn, *mdn2;
+    ULONG mdnsize;
+
+    Status = dev_ioctl(DeviceObject, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
+    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
+        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+        return FALSE;
+    }
+
+    mdnsize = (ULONG)offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
+
+    mdn2 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
+    if (!mdn2) {
+        ERR("out of memory\n");
+        return FALSE;
+    }
+
+    Status = dev_ioctl(DeviceObject, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn2, mdnsize, TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+        ExFreePool(mdn2);
+        return FALSE;
+    }
+
+    if (mdn2->NameLength > wcslen(BTRFS_VOLUME_PREFIX) * sizeof(WCHAR) &&
+        RtlCompareMemory(mdn2->Name, BTRFS_VOLUME_PREFIX, wcslen(BTRFS_VOLUME_PREFIX) * sizeof(WCHAR)) == wcslen(BTRFS_VOLUME_PREFIX) * sizeof(WCHAR)) {
+        ExFreePool(mdn2);
+        return TRUE;
+    }
+
+    ExFreePool(mdn2);
+
+    return FALSE;
+}
+
+static NTSTATUS get_device_pnp_name_guid(_In_ PDEVICE_OBJECT DeviceObject, _Out_ PUNICODE_STRING pnp_name, _In_ const GUID* guid) {
+    NTSTATUS Status;
+    WCHAR *list = NULL, *s;
+
+    Status = IoGetDeviceInterfaces((PVOID)guid, NULL, 0, &list);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IoGetDeviceInterfaces returned %08x\n", Status);
+        return Status;
+    }
+
+    s = list;
+    while (s[0] != 0) {
+        PFILE_OBJECT FileObject;
+        PDEVICE_OBJECT devobj;
+        UNICODE_STRING name;
+
+        name.Length = name.MaximumLength = (USHORT)wcslen(s) * sizeof(WCHAR);
+        name.Buffer = s;
+
+        if (NT_SUCCESS(IoGetDeviceObjectPointer(&name, FILE_READ_ATTRIBUTES, &FileObject, &devobj))) {
+            if (DeviceObject == devobj || DeviceObject == FileObject->DeviceObject) {
+                ObDereferenceObject(FileObject);
+
+                pnp_name->Buffer = ExAllocatePoolWithTag(PagedPool, name.Length, ALLOC_TAG);
+                if (!pnp_name->Buffer) {
+                    ERR("out of memory\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
+                    goto end;
+                }
+
+                RtlCopyMemory(pnp_name->Buffer, name.Buffer, name.Length);
+                pnp_name->Length = pnp_name->MaximumLength = name.Length;
+
+                Status = STATUS_SUCCESS;
+                goto end;
             }
-            le = le->Flink;
+
+            ObDereferenceObject(FileObject);
         }
-        
-        ExReleaseResourceLite(&volumes_lock);
-        
-        le2 = le2->Flink;
+
+        s = &s[wcslen(s) + 1];
     }
-    
+
+    pnp_name->Length = pnp_name->MaximumLength = 0;
+    pnp_name->Buffer = 0;
+
+    Status = STATUS_NOT_FOUND;
+
+end:
+    if (list)
+        ExFreePool(list);
+
+    return Status;
+}
+
+NTSTATUS get_device_pnp_name(_In_ PDEVICE_OBJECT DeviceObject, _Out_ PUNICODE_STRING pnp_name, _Out_ const GUID** guid) {
+    NTSTATUS Status;
+
+    Status = get_device_pnp_name_guid(DeviceObject, pnp_name, &GUID_DEVINTERFACE_VOLUME);
+    if (NT_SUCCESS(Status)) {
+        *guid = &GUID_DEVINTERFACE_VOLUME;
+        return Status;
+    }
+
+    Status = get_device_pnp_name_guid(DeviceObject, pnp_name, &GUID_DEVINTERFACE_HIDDEN_VOLUME);
+    if (NT_SUCCESS(Status)) {
+        *guid = &GUID_DEVINTERFACE_HIDDEN_VOLUME;
+        return Status;
+    }
+
+    Status = get_device_pnp_name_guid(DeviceObject, pnp_name, &GUID_DEVINTERFACE_DISK);
+    if (NT_SUCCESS(Status)) {
+        *guid = &GUID_DEVINTERFACE_DISK;
+        return Status;
+    }
+
+    return STATUS_NOT_FOUND;
+}
+
+_Success_(return>=0)
+static NTSTATUS check_mount_device(_In_ PDEVICE_OBJECT DeviceObject, _Out_ BOOL* no_pnp) {
+    NTSTATUS Status;
+    ULONG to_read;
+    superblock* sb;
+    UINT32 crc32;
+    UNICODE_STRING pnp_name;
+    const GUID* guid;
+
+    to_read = DeviceObject->SectorSize == 0 ? sizeof(superblock) : (ULONG)sector_align(sizeof(superblock), DeviceObject->SectorSize);
+
+    sb = ExAllocatePoolWithTag(NonPagedPool, to_read, ALLOC_TAG);
+    if (!sb) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+
+    Status = sync_read_phys(DeviceObject, superblock_addrs[0], to_read, (PUCHAR)sb, TRUE);
+    if (!NT_SUCCESS(Status)) {
+        ERR("sync_read_phys returned %08x\n", Status);
+        goto end;
+    }
+
+    if (sb->magic != BTRFS_MAGIC) {
+        Status = STATUS_SUCCESS;
+        goto end;
+    }
+
+    crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
+
+    if (crc32 != *((UINT32*)sb->checksum)) {
+        WARN("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)sb->checksum));
+        Status = STATUS_SUCCESS;
+        goto end;
+    }
+
+    DeviceObject->Flags &= ~DO_VERIFY_VOLUME;
+
+    pnp_name.Buffer = NULL;
+
+    Status = get_device_pnp_name(DeviceObject, &pnp_name, &guid);
+    if (!NT_SUCCESS(Status)) {
+        WARN("get_device_pnp_name returned %08x\n", Status);
+        pnp_name.Length = 0;
+    }
+
+    if (pnp_name.Length == 0)
+        *no_pnp = TRUE;
+    else {
+        *no_pnp = FALSE;
+        volume_arrival(drvobj, &pnp_name);
+    }
+
+    if (pnp_name.Buffer)
+        ExFreePool(pnp_name.Buffer);
+
+    Status = STATUS_SUCCESS;
+
+end:
+    ExFreePool(sb);
+
+    return Status;
+}
+
+static BOOL still_has_superblock(_In_ PDEVICE_OBJECT device) {
+    NTSTATUS Status;
+    ULONG to_read;
+    superblock* sb;
+    PDEVICE_OBJECT device2;
+
+    if (!device)
+        return FALSE;
+
+    to_read = device->SectorSize == 0 ? sizeof(superblock) : (ULONG)sector_align(sizeof(superblock), device->SectorSize);
+
+    sb = ExAllocatePoolWithTag(NonPagedPool, to_read, ALLOC_TAG);
+    if (!sb) {
+        ERR("out of memory\n");
+        return FALSE;
+    }
+
+    Status = sync_read_phys(device, superblock_addrs[0], to_read, (PUCHAR)sb, TRUE);
+    if (!NT_SUCCESS(Status)) {
+        ERR("Failed to read superblock: %08x\n", Status);
+        ExFreePool(sb);
+        return FALSE;
+    }
+
+    if (sb->magic != BTRFS_MAGIC) {
+        TRACE("not a BTRFS volume\n");
+        ExFreePool(sb);
+        return FALSE;
+    } else {
+        UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
+
+        if (crc32 != *((UINT32*)sb->checksum)) {
+            WARN("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)sb->checksum));
+            ExFreePool(sb);
+            return FALSE;
+        }
+    }
+
+    device2 = device;
+
+    do {
+        device2->Flags &= ~DO_VERIFY_VOLUME;
+        device2 = IoGetLowerDeviceObject(device2);
+    } while (device2);
+
+    ExFreePool(sb);
     return TRUE;
 }
 
-static NTSTATUS STDCALL mount_vol(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
+static NTSTATUS mount_vol(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp) {
     PIO_STACK_LOCATION IrpSp;
     PDEVICE_OBJECT NewDeviceObject = NULL;
-    PDEVICE_OBJECT DeviceToMount;
+    PDEVICE_OBJECT DeviceToMount, readobj;
     NTSTATUS Status;
     device_extension* Vcb = NULL;
-    GET_LENGTH_INFORMATION gli;
     LIST_ENTRY *le, batchlist;
     KEY searchkey;
     traverse_ptr tp;
@@ -3735,10 +3934,15 @@
     ccb* root_ccb = NULL;
     BOOL init_lookaside = FALSE;
     device* dev;
-    
+    volume_device_extension* vde = NULL;
+    pdo_device_extension* pdode = NULL;
+    volume_child* vc;
+    BOOL no_pnp = FALSE;
+    UINT64 readobjsize;
+
     TRACE("(%p, %p)\n", DeviceObject, Irp);
-    
-    if (DeviceObject != devobj) {
+
+    if (DeviceObject != master_devobj) {
         Status = STATUS_INVALID_DEVICE_REQUEST;
         goto exit;
     }
@@ -3746,13 +3950,105 @@
     IrpSp = IoGetCurrentIrpStackLocation(Irp);
     DeviceToMount = IrpSp->Parameters.MountVolume.DeviceObject;
 
-    Status = dev_ioctl(DeviceToMount, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0, &gli, sizeof(gli), TRUE, NULL);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error reading length information: %08x\n", Status);
-        Status = STATUS_UNRECOGNIZED_VOLUME;
-        goto exit;
+    if (!is_btrfs_volume(DeviceToMount)) {
+        Status = check_mount_device(DeviceToMount, &no_pnp);
+        if (!NT_SUCCESS(Status))
+            WARN("check_mount_device returned %08x\n", Status);
+
+        if (!no_pnp) {
+            Status = STATUS_UNRECOGNIZED_VOLUME;
+            goto exit2;
+        }
+    } else {
+        PDEVICE_OBJECT pdo;
+
+        pdo = DeviceToMount;
+
+        while (IoGetLowerDeviceObject(pdo)) {
+            pdo = IoGetLowerDeviceObject(pdo);
+        }
+
+        ExAcquireResourceSharedLite(&pdo_list_lock, TRUE);
+
+        le = pdo_list.Flink;
+        while (le != &pdo_list) {
+            pdo_device_extension* pdode = CONTAINING_RECORD(le, pdo_device_extension, list_entry);
+
+            if (pdode->pdo == pdo) {
+                vde = pdode->vde;
+                break;
+            }
+
+            le = le->Flink;
+        }
+
+        ExReleaseResourceLite(&pdo_list_lock);
+
+        if (!vde || vde->type != VCB_TYPE_VOLUME) {
+            vde = NULL;
+            Status = STATUS_UNRECOGNIZED_VOLUME;
+            goto exit2;
+        }
     }
 
+    if (vde) {
+        pdode = vde->pdode;
+
+        ExAcquireResourceExclusiveLite(&pdode->child_lock, TRUE);
+
+        le = pdode->children.Flink;
+        while (le != &pdode->children) {
+            LIST_ENTRY* le2 = le->Flink;
+
+            vc = CONTAINING_RECORD(pdode->children.Flink, volume_child, list_entry);
+
+            if (!still_has_superblock(vc->devobj)) {
+                remove_volume_child(vde, vc, FALSE);
+
+                if (pdode->num_children == 0) {
+                    ERR("error - number of devices is zero\n");
+                    Status = STATUS_INTERNAL_ERROR;
+                    goto exit2;
+                }
+
+                Status = STATUS_DEVICE_NOT_READY;
+                goto exit2;
+            }
+
+            le = le2;
+        }
+
+        if (pdode->num_children == 0 || pdode->children_loaded == 0) {
+            ERR("error - number of devices is zero\n");
+            Status = STATUS_INTERNAL_ERROR;
+            goto exit;
+        }
+
+        ExConvertExclusiveToSharedLite(&pdode->child_lock);
+
+        vc = CONTAINING_RECORD(pdode->children.Flink, volume_child, list_entry);
+
+        readobj = vc->devobj;
+        readobjsize = vc->size;
+
+        vde->device->Characteristics &= ~FILE_DEVICE_SECURE_OPEN;
+    } else {
+        GET_LENGTH_INFORMATION gli;
+
+        vc = NULL;
+        readobj = DeviceToMount;
+
+        Status = dev_ioctl(readobj, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
+                           &gli, sizeof(gli), TRUE, NULL);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("error reading length information: %08x\n", Status);
+            goto exit;
+        }
+
+        readobjsize = gli.Length.QuadPart;
+    }
+
     Status = IoCreateDevice(drvobj, sizeof(device_extension), NULL, FILE_DEVICE_DISK_FILE_SYSTEM, 0, FALSE, &NewDeviceObject);
     if (!NT_SUCCESS(Status)) {
         ERR("IoCreateDevice returned %08x\n", Status);
@@ -3759,28 +4055,47 @@
         Status = STATUS_UNRECOGNIZED_VOLUME;
         goto exit;
     }
-    
+
     NewDeviceObject->Flags |= DO_DIRECT_IO;
+
+    // Some programs seem to expect that the sector size will be 512, for
+    // FILE_NO_INTERMEDIATE_BUFFERING and the like.
+    NewDeviceObject->SectorSize = min(DeviceToMount->SectorSize, 512);
+
     Vcb = (PVOID)NewDeviceObject->DeviceExtension;
     RtlZeroMemory(Vcb, sizeof(device_extension));
-    Vcb->type = VCB_TYPE_VOLUME;
-    
+    Vcb->type = VCB_TYPE_FS;
+    Vcb->vde = vde;
+
     ExInitializeResourceLite(&Vcb->tree_lock);
-    Vcb->open_trees = 0;
     Vcb->need_write = FALSE;
 
     ExInitializeResourceLite(&Vcb->fcb_lock);
     ExInitializeResourceLite(&Vcb->chunk_lock);
+    ExInitializeResourceLite(&Vcb->dirty_fcbs_lock);
+    ExInitializeResourceLite(&Vcb->dirty_filerefs_lock);
+    ExInitializeResourceLite(&Vcb->dirty_subvols_lock);
+    ExInitializeResourceLite(&Vcb->scrub.stats_lock);
 
     ExInitializeResourceLite(&Vcb->load_lock);
     ExAcquireResourceExclusiveLite(&Vcb->load_lock, TRUE);
 
+    ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+
     DeviceToMount->Flags |= DO_DIRECT_IO;
-    
-    TRACE("partition length = %llx\n", gli.Length.QuadPart);
 
-    Status = read_superblock(Vcb, DeviceToMount, gli.Length.QuadPart);
+    Status = read_superblock(Vcb, readobj, readobjsize);
     if (!NT_SUCCESS(Status)) {
+        if (!IoIsErrorUserInduced(Status))
+            Status = STATUS_UNRECOGNIZED_VOLUME;
+        else if (Irp->Tail.Overlay.Thread)
+            IoSetHardErrorOrVerifyDevice(Irp, readobj);
+
+        goto exit;
+    }
+
+    if (!vde && Vcb->superblock.num_devices > 1) {
+        ERR("cannot mount multi-device FS with non-PNP device\n");
         Status = STATUS_UNRECOGNIZED_VOLUME;
         goto exit;
     }
@@ -3790,7 +4105,13 @@
         ERR("registry_load_volume_options returned %08x\n", Status);
         goto exit;
     }
-    
+
+    if (pdode && pdode->children_loaded < pdode->num_children && (!Vcb->options.allow_degraded || !finished_probing || degraded_wait)) {
+        ERR("could not mount as %u device(s) missing\n", pdode->num_children - pdode->children_loaded);
+        Status = STATUS_DEVICE_NOT_READY;
+        goto exit;
+    }
+
     if (Vcb->options.ignore) {
         TRACE("ignoring volume\n");
         Status = STATUS_UNRECOGNIZED_VOLUME;
@@ -3802,37 +4123,19 @@
         Status = STATUS_UNRECOGNIZED_VOLUME;
         goto exit;
     }
-    
-    ExAcquireResourceSharedLite(&volumes_lock, TRUE);
-    
-    le = volumes.Flink;
-    while (le != &volumes) {
-        volume* v = CONTAINING_RECORD(le, volume, list_entry);
-        
-        if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID) && v->devnum < Vcb->superblock.dev_item.dev_id) {
-            // skipping over device in RAID which isn't the first one
-            ExReleaseResourceLite(&volumes_lock);
-            Status = STATUS_UNRECOGNIZED_VOLUME;
-            goto exit;
-        }
-        
-        le = le->Flink;
-    }
-    
-    ExReleaseResourceLite(&volumes_lock);
-    
+
     Vcb->readonly = FALSE;
     if (Vcb->superblock.compat_ro_flags & ~COMPAT_RO_SUPPORTED) {
         WARN("mounting read-only because of unsupported flags (%llx)\n", Vcb->superblock.compat_ro_flags & ~COMPAT_RO_SUPPORTED);
         Vcb->readonly = TRUE;
     }
-    
+
     if (Vcb->options.readonly)
         Vcb->readonly = TRUE;
-    
+
     Vcb->superblock.generation++;
     Vcb->superblock.incompat_flags |= BTRFS_INCOMPAT_FLAGS_MIXED_BACKREF;
-    
+
     InitializeListHead(&Vcb->devices);
     dev = ExAllocatePoolWithTag(NonPagedPool, sizeof(device), ALLOC_TAG);
     if (!dev) {
@@ -3840,40 +4143,46 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto exit;
     }
-    
-    dev->devobj = DeviceToMount;
+
+    dev->devobj = readobj;
     RtlCopyMemory(&dev->devitem, &Vcb->superblock.dev_item, sizeof(DEV_ITEM));
-    
+
+    if (dev->devitem.num_bytes > readobjsize) {
+        WARN("device %llx: DEV_ITEM says %llx bytes, but Windows only reports %llx\n", dev->devitem.dev_id,
+                dev->devitem.num_bytes, readobjsize);
+
+        dev->devitem.num_bytes = readobjsize;
+    }
+
     dev->seeding = Vcb->superblock.flags & BTRFS_SUPERBLOCK_FLAGS_SEEDING ? TRUE : FALSE;
-    
-    init_device(Vcb, dev, FALSE, TRUE);
-    dev->length = gli.Length.QuadPart;
-    
+
+    init_device(Vcb, dev, TRUE);
+
     InsertTailList(&Vcb->devices, &dev->list_entry);
     Vcb->devices_loaded = 1;
-    
+
     if (DeviceToMount->Flags & DO_SYSTEM_BOOT_PARTITION)
         Vcb->disallow_dismount = TRUE;
-    
+
     TRACE("DeviceToMount = %p\n", DeviceToMount);
     TRACE("IrpSp->Parameters.MountVolume.Vpb = %p\n", IrpSp->Parameters.MountVolume.Vpb);
 
     NewDeviceObject->StackSize = DeviceToMount->StackSize + 1;
     NewDeviceObject->Flags &= ~DO_DEVICE_INITIALIZING;
-    
+
     InitializeListHead(&Vcb->roots);
     InitializeListHead(&Vcb->drop_roots);
-    
+
     Vcb->log_to_phys_loaded = FALSE;
-    
-    add_root(Vcb, BTRFS_ROOT_CHUNK, Vcb->superblock.chunk_tree_addr, NULL);
-    
+
+    add_root(Vcb, BTRFS_ROOT_CHUNK, Vcb->superblock.chunk_tree_addr, Vcb->superblock.chunk_root_generation, NULL);
+
     if (!Vcb->chunk_root) {
         ERR("Could not load chunk root.\n");
         Status = STATUS_INTERNAL_ERROR;
         goto exit;
     }
-       
+
     InitializeListHead(&Vcb->sys_chunks);
     Status = load_sys_chunks(Vcb);
     if (!NT_SUCCESS(Status)) {
@@ -3880,75 +4189,71 @@
         ERR("load_sys_chunks returned %08x\n", Status);
         goto exit;
     }
-    
+
     InitializeListHead(&Vcb->chunks);
-    InitializeListHead(&Vcb->chunks_changed);
     InitializeListHead(&Vcb->trees);
     InitializeListHead(&Vcb->trees_hash);
     InitializeListHead(&Vcb->all_fcbs);
     InitializeListHead(&Vcb->dirty_fcbs);
     InitializeListHead(&Vcb->dirty_filerefs);
-    
-    KeInitializeSpinLock(&Vcb->dirty_fcbs_lock);
-    KeInitializeSpinLock(&Vcb->dirty_filerefs_lock);
-    
+    InitializeListHead(&Vcb->dirty_subvols);
+    InitializeListHead(&Vcb->send_ops);
+
     InitializeListHead(&Vcb->DirNotifyList);
+    InitializeListHead(&Vcb->scrub.errors);
 
     FsRtlNotifyInitializeSync(&Vcb->NotifySync);
-    
+
     ExInitializePagedLookasideList(&Vcb->tree_data_lookaside, NULL, NULL, 0, sizeof(tree_data), ALLOC_TAG, 0);
     ExInitializePagedLookasideList(&Vcb->traverse_ptr_lookaside, NULL, NULL, 0, sizeof(traverse_ptr), ALLOC_TAG, 0);
-    ExInitializePagedLookasideList(&Vcb->rollback_item_lookaside, NULL, NULL, 0, sizeof(rollback_item), ALLOC_TAG, 0);
     ExInitializePagedLookasideList(&Vcb->batch_item_lookaside, NULL, NULL, 0, sizeof(batch_item), ALLOC_TAG, 0);
+    ExInitializePagedLookasideList(&Vcb->fileref_lookaside, NULL, NULL, 0, sizeof(file_ref), ALLOC_TAG, 0);
+    ExInitializePagedLookasideList(&Vcb->fcb_lookaside, NULL, NULL, 0, sizeof(fcb), ALLOC_TAG, 0);
+    ExInitializePagedLookasideList(&Vcb->name_bit_lookaside, NULL, NULL, 0, sizeof(name_bit), ALLOC_TAG, 0);
     ExInitializeNPagedLookasideList(&Vcb->range_lock_lookaside, NULL, NULL, 0, sizeof(range_lock), ALLOC_TAG, 0);
+    ExInitializeNPagedLookasideList(&Vcb->fileref_np_lookaside, NULL, NULL, 0, sizeof(file_ref_nonpaged), ALLOC_TAG, 0);
+    ExInitializeNPagedLookasideList(&Vcb->fcb_np_lookaside, NULL, NULL, 0, sizeof(fcb_nonpaged), ALLOC_TAG, 0);
     init_lookaside = TRUE;
-    
+
+    Vcb->Vpb = IrpSp->Parameters.MountVolume.Vpb;
+
     Status = load_chunk_root(Vcb, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("load_chunk_root returned %08x\n", Status);
         goto exit;
     }
-    
+
     if (Vcb->superblock.num_devices > 1) {
-        if (Vcb->devices_loaded < Vcb->superblock.num_devices) {
+        if (Vcb->devices_loaded < Vcb->superblock.num_devices && (!Vcb->options.allow_degraded || !finished_probing)) {
             ERR("could not mount as %u device(s) missing\n", Vcb->superblock.num_devices - Vcb->devices_loaded);
-            
+
             IoRaiseInformationalHardError(IO_ERR_INTERNAL_ERROR, NULL, NULL);
 
             Status = STATUS_INTERNAL_ERROR;
             goto exit;
         }
-        
+
         if (dev->readonly && !Vcb->readonly) {
             Vcb->readonly = TRUE;
-            
+
             le = Vcb->devices.Flink;
             while (le != &Vcb->devices) {
                 device* dev2 = CONTAINING_RECORD(le, device, list_entry);
-                
+
                 if (dev2->readonly && !dev2->seeding)
                     break;
-                
+
                 if (!dev2->readonly) {
                     Vcb->readonly = FALSE;
                     break;
                 }
-                
+
                 le = le->Flink;
             }
-            
+
             if (Vcb->readonly)
                 WARN("setting volume to readonly\n");
         }
-        
-        if (!raid_generations_okay(Vcb)) {
-            ERR("could not mount as generation mismatch\n");
-            
-            IoRaiseInformationalHardError(IO_ERR_INTERNAL_ERROR, NULL, NULL);
-
-            Status = STATUS_INTERNAL_ERROR;
-            goto exit;
-        }
     } else {
         if (dev->readonly) {
             WARN("setting volume to readonly as device is readonly\n");
@@ -3955,32 +4260,43 @@
             Vcb->readonly = TRUE;
         }
     }
-    
-    add_root(Vcb, BTRFS_ROOT_ROOT, Vcb->superblock.root_tree_addr, NULL);
-    
+
+    add_root(Vcb, BTRFS_ROOT_ROOT, Vcb->superblock.root_tree_addr, Vcb->superblock.generation - 1, NULL);
+
     if (!Vcb->root_root) {
         ERR("Could not load root of roots.\n");
         Status = STATUS_INTERNAL_ERROR;
         goto exit;
     }
-    
+
     Status = look_for_roots(Vcb, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("look_for_roots returned %08x\n", Status);
         goto exit;
     }
-    
-    Status = find_chunk_usage(Vcb, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("find_chunk_usage returned %08x\n", Status);
-        goto exit;
+
+    if (!Vcb->readonly) {
+        Status = find_chunk_usage(Vcb, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("find_chunk_usage returned %08x\n", Status);
+            goto exit;
+        }
     }
-    
+
     InitializeListHead(&batchlist);
-    
+
     // We've already increased the generation by one
-    if (!Vcb->readonly && Vcb->superblock.generation - 1 != Vcb->superblock.cache_generation) {
-        WARN("generation was %llx, free-space cache generation was %llx; clearing cache...\n", Vcb->superblock.generation - 1, Vcb->superblock.cache_generation);
+    if (!Vcb->readonly && (
+        Vcb->options.clear_cache ||
+        (!(Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE) && Vcb->superblock.generation - 1 != Vcb->superblock.cache_generation) ||
+        (Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE && !(Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE_VALID)))) {
+        if (Vcb->options.clear_cache)
+            WARN("ClearCache option was set, clearing cache...\n");
+        else if (Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE && !(Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE_VALID))
+            WARN("clearing free-space tree created by buggy Linux driver\n");
+        else
+            WARN("generation was %llx, free-space cache generation was %llx; clearing cache...\n", Vcb->superblock.generation - 1, Vcb->superblock.cache_generation);
+
         Status = clear_free_space_cache(Vcb, &batchlist, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("clear_free_space_cache returned %08x\n", Status);
